"use strict";Object.defineProperty(exports, "__esModule", { value: true });exports.handleMediaResponse = exports.handleSingleMediaUpload = exports.handleMediaUpload = undefined;var _extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};var _lodash = require("lodash");var _lodash2 = _interopRequireDefault(_lodash);
var _async = require("async");var _async2 = _interopRequireDefault(_async);
var _uuid = require("uuid");var _uuid2 = _interopRequireDefault(_uuid);
var _settings = require("./settings");function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { default: obj };}function _asyncToGenerator(fn) {return function () {var gen = fn.apply(this, arguments);return new Promise(function (resolve, reject) {function step(key, arg) {try {var info = gen[key](arg);var value = info.value;} catch (error) {reject(error);return;}if (info.done) {resolve(value);} else {return Promise.resolve(value).then(function (value) {step("next", value);}, function (err) {step("throw", err);});}}return step("next");});};}

var fs = require('fs');

var handleMediaUpload = exports.handleMediaUpload = function handleMediaUpload(data) {
    return new Promise(function (resolve) {

        var body = _lodash2.default.clone(data);

        _async2.default.forEachOf(body, function () {var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(item, key, done) {var kk;return regeneratorRuntime.wrap(function _callee$(_context) {while (1) {switch (_context.prev = _context.next) {case 0:

                                if (_lodash2.default.isArray(item)) {

                                    kk = [];

                                    _async2.default.each(item, function (file, next) {

                                        var x = file.originFileObj;
                                        if (x !== undefined) {var
                                            filename = file.response.filename;

                                            kk.push({
                                                uid: _uuid2.default.v1(),
                                                name: file.name,
                                                path: "./public/media/" + filename,
                                                url: "/media/" + filename });


                                            fs.rename("./public/tempFiles/" + filename, "./public/media/" + filename, function (err) {
                                                if (err) console.log(err);
                                                next();
                                            });


                                        } else {
                                            kk.push(file);
                                            next();
                                        }

                                    }, function () {

                                        body[key] = kk;
                                        done();
                                    });

                                } else {
                                    done();
                                }case 1:case "end":return _context.stop();}}}, _callee, undefined);}));return function (_x, _x2, _x3) {return _ref.apply(this, arguments);};}(),

        function () {

            resolve(body);

        });
    });
};

var handleSingleMediaUpload = exports.handleSingleMediaUpload = function handleSingleMediaUpload(data) {
    return new Promise(function (resolve) {

        var body = _lodash2.default.clone(data);

        _async2.default.forEachOf(body, function () {var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(item, key, done) {var kk, file, x, filename;return regeneratorRuntime.wrap(function _callee2$(_context2) {while (1) {switch (_context2.prev = _context2.next) {case 0:

                                if (_lodash2.default.isObject(item)) {

                                    console.log(item);

                                    kk = [];

                                    file = item;

                                    x = file.originFileObj;
                                    if (x !== undefined) {
                                        filename = file.response.filename;

                                        kk = {
                                            uid: _uuid2.default.v1(),
                                            name: file.name,
                                            path: "./public/media/" + filename,
                                            url: "/media/" + filename };


                                        fs.rename("./public/tempFiles/" + filename, "./public/media/" + filename, function (err) {
                                            if (err) console.log(err);
                                            body[key] = kk;
                                            done();
                                        });


                                    } else {
                                        done();
                                    }

                                } else {
                                    done();
                                }case 1:case "end":return _context2.stop();}}}, _callee2, undefined);}));return function (_x4, _x5, _x6) {return _ref2.apply(this, arguments);};}(),

        function () {

            resolve(body);

        });
    });
};

var handleMediaResponse = exports.handleMediaResponse = function handleMediaResponse(data, url) {
    return new Promise(function (resolve) {

        var body = _lodash2.default.clone(data);

        if (_lodash2.default.isArray(body)) {
            _async2.default.each(body, function (singleObj, singCll) {

                _async2.default.forEachOf(singleObj, function () {var _ref3 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(item, key, done) {var kk;return regeneratorRuntime.wrap(function _callee3$(_context3) {while (1) {switch (_context3.prev = _context3.next) {case 0:

                                        if (_lodash2.default.isArray(item)) {

                                            kk = [];
                                            _async2.default.each(item, function (file, next) {

                                                var x = file.path && file.uid;
                                                kk.push(_extends({ status: 'done' }, file, { url: "" + url + file.url }));
                                                next();

                                            }, function () {
                                                singleObj[key] = kk;
                                                done();
                                            });

                                        } else {
                                            done();
                                        }case 1:case "end":return _context3.stop();}}}, _callee3, undefined);}));return function (_x7, _x8, _x9) {return _ref3.apply(this, arguments);};}(),

                function () {
                    singCll();
                });
            }, function () {
                resolve(body);
            });

        } else {

            _async2.default.forEachOf(body, function () {var _ref4 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(item, key, done) {var kk;return regeneratorRuntime.wrap(function _callee4$(_context4) {while (1) {switch (_context4.prev = _context4.next) {case 0:

                                    if (_lodash2.default.isArray(item)) {

                                        kk = [];
                                        _async2.default.each(item, function (file, next) {

                                            var x = file.path && file.uid;
                                            kk.push(_extends({ status: 'done' }, file, { url: "" + url + file.url }));

                                            next();

                                        }, function () {

                                            body[key] = kk;
                                            done();
                                        });

                                    } else {
                                        done();
                                    }case 1:case "end":return _context4.stop();}}}, _callee4, undefined);}));return function (_x10, _x11, _x12) {return _ref4.apply(this, arguments);};}(),

            function () {

                resolve(body);

            });
        }

    });
};exports.default =

{};